//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_RenderObjectHandlerWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(RenderObjectHandler), typeof(UnityEngine.MonoBehaviour));
		L.RegFunction("SetMats",FUNCTAG_SetMats);
		L.RegFunction("DoMatsActionList",FUNCTAG_DoMatsActionList);
		L.RegFunction("SetMatsColor",FUNCTAG_SetMatsColor);
		L.RegFunction("SetMatsFloat",FUNCTAG_SetMatsFloat);
		L.RegFunction("SetMatsInt",FUNCTAG_SetMatsInt);
		L.RegFunction("SetMatsVector",FUNCTAG_SetMatsVector);
		L.RegFunction("RenderAddMat",FUNCTAG_RenderAddMat);
		L.RegFunction("RenderDelMat",FUNCTAG_RenderDelMat);
		L.RegFunction("AddRenderObj",FUNCTAG_AddRenderObj);
		L.RegFunction("DelRenderObj",FUNCTAG_DelRenderObj);
		L.RegFunction("RenderResizeMatCnt",FUNCTAG_RenderResizeMatCnt);
		L.RegFunction("FadeShow",FUNCTAG_FadeShow);
		L.RegFunction("FadeHide",FUNCTAG_FadeHide);
		L.RegFunction("GetBatchObject",FUNCTAG_GetBatchObject);
		L.RegFunction("BatchCall",FUNCTAG_BatchCall);
		L.RegVar("shadowHeight",null, FUNCTAG_set_shadowHeight);
		L.RegVar("matColor",null, FUNCTAG_set_matColor);
		L.RegVar("outline",null, FUNCTAG_set_outline);
		L.RegVar("isIndependentUpdate",FUNCTAG_get_isIndependentUpdate, FUNCTAG_set_isIndependentUpdate);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetMats(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			LuaTable arg0 = ToLua.CheckLuaTable(L, 2);
			obj.SetMats(arg0);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_DoMatsActionList(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			obj.DoMatsActionList();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetMatsColor(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			UnityEngine.Color arg1 = ToLua.ToColor(L, 3);
			obj.SetMatsColor(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetMatsFloat(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			float arg1 = (float)LuaDLL.luaL_checknumber(L, 3);
			obj.SetMatsFloat(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetMatsInt(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			int arg1 = (int)LuaDLL.luaL_checknumber(L, 3);
			obj.SetMatsInt(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetMatsVector(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			UnityEngine.Vector4 arg1 = ToLua.ToVector4(L, 3);
			obj.SetMatsVector(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RenderAddMat(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			UnityEngine.Renderer arg0 = (UnityEngine.Renderer)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Renderer));
			UnityEngine.Material arg1 = (UnityEngine.Material)ToLua.CheckUnityObject(L, 3, typeof(UnityEngine.Material));
			obj.RenderAddMat(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RenderDelMat(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			UnityEngine.Renderer arg0 = (UnityEngine.Renderer)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Renderer));
			string arg1 = ToLua.CheckString(L, 3);
			obj.RenderDelMat(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RenderResizeMatCnt(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			UnityEngine.Renderer arg0 = (UnityEngine.Renderer)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Renderer));
			int arg1 = (int)LuaDLL.luaL_checknumber(L, 3);
			obj.RenderResizeMatCnt(arg0, arg1);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}


	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_FadeShow(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			float arg1 = (float)LuaDLL.luaL_checknumber(L, 3);
			obj.FadeShow(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}


	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_FadeHide(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			string arg0 = ToLua.CheckString(L, 2);
			float arg1 = (float)LuaDLL.luaL_checknumber(L, 3);
			obj.FadeHide(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetBatchObject(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 1);
			RenderObjectHandler o = RenderObjectHandler.GetBatchObject(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_shadowHeight(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			RenderObjectHandler obj = (RenderObjectHandler)o;
			float arg0 = (float)LuaDLL.luaL_checknumber(L, 2);
			obj.shadowHeight = arg0;
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index shadowHeight on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_isIndependentUpdate(IntPtr L)
	{
		object o = null;

		try
		{
			ToLua.CheckArgsCount(L, 2);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			bool b = LuaDLL.tolua_toboolean (L, 2);
			obj.isIndependentUpdate = b;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index shadowHeight on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_isIndependentUpdate(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			RenderObjectHandler obj = (RenderObjectHandler)o;
			ToLua.Push(L, obj.isIndependentUpdate);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index shadowHeight on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_matColor(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			RenderObjectHandler obj = (RenderObjectHandler)o;
			UnityEngine.Color arg0 = ToLua.ToColor(L, 2);
			obj.matColor = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index matColor on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_outline(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			RenderObjectHandler obj = (RenderObjectHandler)o;
			float arg0 = (float)LuaDLL.luaL_checknumber(L, 2);
			obj.outline = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index outline on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_AddRenderObj(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			var rend3 = ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Renderer)) as UnityEngine.Renderer;
			obj.AddRenderObj(rend3);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_DelRenderObj(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			RenderObjectHandler obj = (RenderObjectHandler)ToLua.CheckObject(L, 1, typeof(RenderObjectHandler));
			var rend3 = ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Renderer)) as UnityEngine.Renderer;
			var cnt = LuaDLL.lua_tointeger(L, 3);
			obj.DelRenderObj(rend3, cnt);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
	public enum BactchCallFuncType
	{
		SetMatsColor = 1,
		SetMatsFloat = 2,
		SetMatsInt = 3,
		SetMatsVector = 4,
		DoMatsActionList = 5,
		SetMats = 6,
		shadowHeight = 7,
		matColor = 8,
		outline = 9,
		RenderAddMat = 10,
		RenderResizeMatCnt = 11,
		FadeShow = 12,
		FadeHide = 13,
		RenderDelMat = 14,
		AddRenderObj = 15,
		DelRenderObj = 16,
	}
	private static void CallOne(RenderObjectHandler obj, Action<RenderObjectHandler> action)
	{
		try
		{
			if (obj != null)
			{
				action(obj);
			}
		}
		catch (Exception e)
		{
			GameDebug.LogError(e.ToString());
		}
	}

	private static int CallByType(IntPtr L, int objId, BactchCallFuncType funcType,int argIdx)
	{
		RenderObjectHandler obj = RenderObjectHandler.GetBatchObject(objId);
		switch(funcType)
		{
			case BactchCallFuncType.SetMatsColor:
				CallOne(obj, (o) => { o.SetMatsColor(ToLua.CheckString(L, argIdx + 1), ToLua.ToColor(L, argIdx + 2)); });
				return 2;
			case BactchCallFuncType.SetMatsFloat:
				CallOne(obj, (o) => { o.SetMatsFloat(ToLua.CheckString(L, argIdx + 1), (float)LuaDLL.luaL_checknumber(L, argIdx + 2)); });
				return 2;
			case BactchCallFuncType.SetMatsInt:
				CallOne(obj, (o) => { o.SetMatsInt(ToLua.CheckString(L, argIdx + 1), LuaDLL.lua_tointeger(L, argIdx + 2)); });
				return 2;
			case BactchCallFuncType.SetMatsVector:
				CallOne(obj, (o) => { o.SetMatsVector(ToLua.CheckString(L, argIdx + 1), ToLua.ToVector4(L, argIdx + 2)); });
				return 2;
			case BactchCallFuncType.DoMatsActionList:
				CallOne(obj, (o) => { o.DoMatsActionList(); });
				return 0;
			case BactchCallFuncType.SetMats:
				CallOne(obj, (o) => { o.SetMats(ToLua.CheckLuaTable(L, argIdx + 1)); });
				return 1;
			case BactchCallFuncType.shadowHeight:
				CallOne(obj, (o) => { o.shadowHeight = (float)LuaDLL.luaL_checknumber(L, argIdx + 1); });
				return 1;
			case BactchCallFuncType.matColor:
				CallOne(obj, (o) => { o.matColor = ToLua.ToColor(L, argIdx + 1); });
				return 1;
			case BactchCallFuncType.outline:
				CallOne(obj, (o) => { o.outline = (float)LuaDLL.luaL_checknumber(L, argIdx + 1); });
				return 1;
			case BactchCallFuncType.RenderAddMat:
				CallOne(obj, (o) => {
					var rend1 = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Renderer;
					var mat = ToLua.ToObject(L, argIdx + 2) as UnityEngine.Material;
					o.RenderAddMat(rend1, mat);
				});
				return 2;
			case BactchCallFuncType.RenderResizeMatCnt:
				CallOne(obj, (o) => {
					var rend2 = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Renderer;
					var cnt = LuaDLL.lua_tointeger(L, argIdx + 2);
					o.RenderResizeMatCnt(rend2, cnt);
				});
				return 2;
			case BactchCallFuncType.FadeShow:
				CallOne(obj, (o) => {
					string name1 = ToLua.CheckString(L, argIdx + 1);
					float time1 = (float)LuaDLL.luaL_checknumber(L, argIdx + 2);
					o.FadeShow(name1, time1);
				});
				return 2;
			case BactchCallFuncType.FadeHide:
				CallOne(obj, (o) => {
					string name2 = ToLua.CheckString(L, argIdx + 1);
					float time2 = (float)LuaDLL.luaL_checknumber(L, argIdx + 2);
					o.FadeHide(name2, time2);
				});
				return 2;
			case BactchCallFuncType.RenderDelMat:
				CallOne(obj, (o) => {
					var rend3 = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Renderer;
					string name3 = ToLua.CheckString(L, argIdx + 2);
					o.RenderDelMat(rend3, name3);
				});
				return 2;
			case BactchCallFuncType.AddRenderObj:
				CallOne(obj, (o) => {
					o.AddRenderObj(ToLua.ToObject(L, argIdx + 1) as UnityEngine.Renderer);
				});
				return 1;
			case BactchCallFuncType.DelRenderObj:
				CallOne(obj, (o) => {
					var rend3 = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Renderer;
					var cnt = LuaDLL.lua_tointeger(L, argIdx + 2);
					o.DelRenderObj(rend3, cnt);
				});
				return 2;
			default:
				Debugger.LogError("unprocess batch call:" + funcType);
				return 0;
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	public static int FUNCTAG_BatchCall(IntPtr L)
	{
		try
		{
			int argIdx = 0;
			int callCnt = LuaDLL.lua_tointeger(L, ++argIdx);
			for (int i = 0; i < callCnt; i++)
			{
				int objId = LuaDLL.lua_tointeger(L, ++argIdx);
				BactchCallFuncType funcType = (BactchCallFuncType)LuaDLL.lua_tointeger(L, ++argIdx);
				argIdx = argIdx + CallByType(L, objId, funcType, argIdx);
			}
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
}

